package net.t2code.t2codelib.SPIGOT.system.config.config;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriter;
import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.T2CconfigItem;
import net.t2code.t2codelib.Util;

import java.io.File;
import java.util.*;

public class T2CLibConfig {

    public enum VALUES implements T2CconfigItem {

        updateCheckOnJoin("plugin.updateCheck.onJoin", true, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Mit dieser Option kannst du festlegen, ob Spieler mit der Berechtigung 't2code.lib.updatemsg' beim Join eine Update-Nachricht erhalten, wenn ein Update für das Plugin verfügbar ist."));
                    put(T2CLanguageEnum.english, List.of("In this option you can set if players with the permission 't2code.lib.updatemsg' will get an update message on join when an update for the plugin is available."));
                }}),

        updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Mit dieser Option kannst du das Zeitintervall in Minuten festlegen, in dem Aktualisierungen überprüft werden sollen."));
                    put(T2CLanguageEnum.english, List.of("In this option you can set the time interval in minutes in which updates should be checked."));
                }}),

        seePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("In dieser Option kannst du einstellen, ob du Beta- und Snapshot-Versionen in der Update-Prüfung erhalten und anzeigen möchten."));
                    put(T2CLanguageEnum.english, List.of("In this option you can set whether you want to receive and display beta and snapshot versions in the update check."));
                }}),

        updateCheckFullDisable("plugin.updateCheck.allPlugins.fullDisable", false, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Option deaktiviert alle Aktualisierungsprüfungen für Plugins, die die T2CodeLib verwenden."));
                    put(T2CLanguageEnum.english, List.of("This option deactivates all update checks for plugins that use the T2CodeLib."));
                }}),

        debug("plugin.debug.debugModus", false, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Der Debug-Modus sendet ausführlichere Debug-Informationen an die Konsole.", "In dieser Version des Plugins sind keine Debug-Meldungen eingebaut!"));
                    put(T2CLanguageEnum.english, List.of("The debug mode sends more detailed debug information to the console.", "In this version of the plugin no debug messages are built in!"));
                }}),

        developerTool("plugin.debug.developerTool", false, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Option aktiviert erweiterte Werkzeuge für die Entwickler von Plugins, die die T2CodeLib verwenden.", "Wenn du nicht genau weist, wozu das gut ist, solltest du es deaktiviert lassen!"));
                    put(T2CLanguageEnum.english, List.of("This option activates advanced tools for the developers of plugins that use the T2CodeLib.", "If you don't know exactly what this is for, you should leave it deactivated!"));
                }}),

        language("plugin.language", "english", true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("In dieser Option kannst du die Sprache des Plugins einstellen."));
                    put(T2CLanguageEnum.english, List.of("In this option you can set the language of the plugin."));
                }}),

        space_proxy("proxy", null, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),
        proxy("proxy.enable", T2CodeLibMain.getIsBungee(), true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Option muss aktiviert werden, wenn du die T2CodeLib auf einem BungeeCord, Waterfall oder Velocity Proxy als Bridge verwenden möchtest."
                            , "Bitte beachte, dass die einzelnen APIs der Plugins, die eine Bridge auf einem Proxy verwenden, in der config.yml der T2CodeLib auf dem Proxy aktiviert werden müssen!"));
                    put(T2CLanguageEnum.english, List.of("This option must be activated if you use the T2CodeLib on a BungeeCord, Waterfall or Velocity Proxy as a bridge."
                            , "Please note that the individual APIs of the plugins that use a bridge on a proxy must be activated in the config.yml of the T2CodeLib on the proxy!"));
                }}),

        serverUUID("proxy.serverUUID", UUID.randomUUID(), true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese UUID wird für die Kommunikation der Plugins in einem Netzwerk mit mehreren Servern verwendet.", "Diese UUID darf nur einmal in einem Netz vorkommen!"));
                    put(T2CLanguageEnum.english, List.of("This UUID is used for the communication of the plugins in a network with several servers.", "This UUID may only occur once in a network!"));
                }}),

        space_player("player", null, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        inventoriesCloseByServerStop("player.inventories.closeByServerStop", true, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Wenn diese Option aktiviert ist, werden bei allen Spielern auf dem Server (Spigot, Papier, etc.) das Inventar / GUIs geschlossen, wenn der Server heruntergefahren oder neu gestartet wird.",
                            "(Damit ist nicht das gesamte Netz gemeint, wenn ein Proxy verwendet wird)"));
                    put(T2CLanguageEnum.english, List.of("If this option is enabled, all players on the server (spigot, paper, etc.) will have their inventory / GUIs closed when the server is shut down or restarted.",
                            "(This does not mean the entire network if a proxy is used)"));

                }}),

        space_command("command", null, true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of());
                    put(T2CLanguageEnum.english, List.of());
                }}),

        commandPermToggleCommand("command.permToggle.permissionSetCommand", "lp user [player] permission set [perm] [value]", true,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Option gibt an, welcher Befehl für den T2CodeLib-Befehl '/t2code permtoggle <player> <permission>' verwendet werden soll."));
                    put(T2CLanguageEnum.english, List.of("This option specifies which command is to be used for the T2CodeLib command '/t2code permtoggle <player> <permission>'."));
                }}),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2CLanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2CLanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2CLanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return language.path;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean pluginStart) {
        long long_ = System.currentTimeMillis();
        ConvertT2ClibConfig.convert();
        T2CconfigWriter.createConfig(new File(T2CodeLibMain.getPath(), "config.yml"), VALUES.values(), Util.getConfigLogo());

        T2Ctemplate.setCenterAligned(Util.getPrefix(), "§2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms", pluginStart);
    }

}
