// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.system.config.languages;


import lombok.NonNull;
import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItemLanguages;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriterLanguage;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import net.t2code.t2codelib.Util;

import java.util.*;

public class T2CLibLanguages {

    public enum VALUES implements T2CconfigItemLanguages {
        otherLang("plugin", null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, null);
                    put(T2CLanguageEnum.english, null);
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.", ""));
                    put(T2CLanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.", ""));
                }}),

        vaultNotSetUp("plugin.vaultNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] &4Vault / Economy nicht eingerichtet!");
                    put(T2CLanguageEnum.english, "[prefix] &4Vault / Economy not set up!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Plugin auf die Vault Schnittstelle von T2CodeLib zugreift und Vault oder kein Economy System vorhanden ist."));
                    put(T2CLanguageEnum.english, List.of("This message is displayed if a plugin accesses the Vault interface of T2CodeLib and Vault or no Economy System is available."));
                }}),

        votingPluginNotSetUp("plugin.votingPluginNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] &4VotingPlugin ist auf dem Server nicht vorhanden!");
                    put(T2CLanguageEnum.english, "[prefix] &4VotingPlugin is not present on the server!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Plugin auf die VotingPlugin Schnittstelle von T2CodeLib zugreift und VotingPlugin nicht vorhanden ist.", "VotingPlugin: https://spigotmc.org/resources/votingplugin.15358/"));
                    put(T2CLanguageEnum.english, List.of("This message is displayed if a plugin accesses the VotingPlugin interface of T2CodeLib and VotingPlugin is not available.", "VotingPlugin: https://spigotmc.org/resources/votingplugin.15358/"));
                }}),
        soundNotFound("plugin.soundNotFound",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, "[prefix] &4Der Sound &6[sound] &4wurde nicht gefunden! Bitte überprüfe die Einstellungen.");
                    put(T2CLanguageEnum.english, "[prefix] &4The sound &6[sound] &4was not found! Please check the settings.");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.german, List.of("Diese Meldung wird angezeigt, wenn ein Sound über die T2CodeLib abgespielt werden soll, den es nicht gibt"));
                    put(T2CLanguageEnum.english, List.of());
                }}),

        ;

        private final String path;
        private Object value;
        private final HashMap<T2CLanguageEnum, String> lang;
        private final HashMap<T2CLanguageEnum, List<String>> comments;

        VALUES(String path, Object value, @NonNull HashMap<T2CLanguageEnum, String> lang, HashMap<T2CLanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2CLanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2CLanguageEnum, String> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2CLanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean pluginStart) {
        T2CconfigWriterLanguage.createConfig(Util.getPrefix(), T2CodeLibMain.getPath(), VALUES.values(), T2CLibConfig.VALUES.language.getValue().toString(), pluginStart, Util.getConfigLogo());

    }
}